/*
		Author:		T. Richner
		Date:		06.01.2010
		Project:	Demo for K8055 

		Description:
		 Shows how to program the K8055 Board with Visual C++
		
		Info:
		-there might be a Warning like "Stack variable corrupted", this is not a Bug
		-loosely based on J. Schyma's Framework, thanks to him
		-the program doesn't throw an error if a K8055 Board is connected with the PC but you took the wrong adress (wrong in .dll? feature?)

*/

#include "stdafx.h"

#include <iostream>
#include "K8055_C.h"
#include <tchar.h>

using namespace std;

int _tmain(int argc, _TCHAR* argv[])
{
	long device = -1;
	long result = 2;
	int nbr;
	bool port[8];

	for(int i=0; i<8;i++)
		port[i] = false;

	cout << "by T. Richner\n\n";
	cout << "HELP: \n for Numbers 1-8: the specified Port toggles \n for Numbers  >8: the Test-Mode starts \n for Numbers  <1: Program close";
	cout << endl << endl;

	cout << "board adress: \t";
	cin >> device;

	result = OpenDevice(device);

	// Check data
	if(result != 0){
		while(true){
			
			cout << "port number: \t";
			cin >> nbr;
			nbr--;
			if(nbr<0)
				break;
			else if(nbr>7){
				int n=0;
				while(n<160){ //toggles 100x times a Port
					port[n%8]=false;
					ClearDigitalChannel(n%8+1);
					n++;
					port[n%8] = true;
					SetDigitalChannel(n%8+1);
					Sleep(50);
				}
				ClearDigitalChannel(n%8+1);
			}
			else{
				port[nbr] = !port[nbr];	//toggles the specified Port-mode
				if(port[nbr]==true)
					SetDigitalChannel(nbr+1);//Turns the specified Port on
				if(port[nbr]==false)
					ClearDigitalChannel(nbr+1);//Turns the specified Port off
			}
		}
		ClearAllDigital();
		CloseDevice();
	}
	else{
		cout << "Could not connect to the device" << endl << endl;
	}
	system("PAUSE");
	return 0;
}